<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="合同编号" prop="contract_no">
                    <el-input v-model="formData.contract_no" clearable placeholder="请输入合同编号" />
                </el-form-item>
                <el-form-item label="1公司2个人" prop="type">
                    <el-input v-model="formData.type" clearable placeholder="请输入1公司2个人" />
                </el-form-item>
                <el-form-item label="签约后的合同" prop="contract_url">
                    <el-input v-model="formData.contract_url" clearable placeholder="请输入签约后的合同" />
                </el-form-item>
                <el-form-item label="证据包" prop="evidence_url">
                    <el-input v-model="formData.evidence_url" clearable placeholder="请输入证据包" />
                </el-form-item>
                <el-form-item label="合同多方链接" prop="url">
                    <el-input v-model="formData.url" clearable placeholder="请输入合同多方链接" />
                </el-form-item>
                <el-form-item label="签约计时器" prop="signing_timer">
                    <el-input v-model="formData.signing_timer" clearable placeholder="请输入签约计时器" />
                </el-form-item>

            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="shopContractEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiShopContractAdd, apiShopContractEdit, apiShopContractDetail } from '@/api/shop_contract'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑商户合同' : '新增商户合同'
})

// 表单数据
const formData = reactive({
    id: '',
    contract_no: '',
    type: '',
    contract_url: '',
    evidence_url: '',
    url: '',
    signing_timer: '',

})


// 表单验证
const formRules = reactive<any>({

})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiShopContractDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiShopContractEdit(data) 
        : await apiShopContractAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
